#include <iostream>

using namespace std;

int main()
{
    int N;
    int brO , brA, brB, brAB;
    cin >> N;
    cin >>brO >> brA >> brB >> brAB;

    string krvnaGrupa;
    int brojDoza;
    int dodeljeneJedinice[N][4];
    int zamenaAB[N][2];
    int zaZamenuAB = 0;
    for (int i=0 ; i<N; i++)
    {
        cin >> krvnaGrupa>>brojDoza;
        if(krvnaGrupa == "O")
        {
            if(brO>= brojDoza)
            {
                brO=brO-brojDoza;
                dodeljeneJedinice[i][0] = brojDoza;
                dodeljeneJedinice[i][1]=0;
                dodeljeneJedinice[i][2]=0;
                dodeljeneJedinice[i][3]=0;
            }
            else
            {
                cout<< "nemoguce";
                return 0;
            }
        }
        if(krvnaGrupa == "A")
        {
            if(brA>=brojDoza)
            {
                brA=brA-brojDoza;
                dodeljeneJedinice[i][1] = brojDoza;
                 dodeljeneJedinice[i][0]=0;
                  dodeljeneJedinice[i][2]=0;
                   dodeljeneJedinice[i][3]=0;
            }
            else if(brO>=brojDoza-brA)
            {

                dodeljeneJedinice[i][0] = brojDoza-brA;
                 dodeljeneJedinice[i][2]=0;
                  dodeljeneJedinice[i][3]=0;
                dodeljeneJedinice[i][1] = brA;
                brA=0;
                brO=brO-(brojDoza-brA);
            }
            else
            {
                cout<< "nemoguce";
               return 0;
            }
        }
        if(krvnaGrupa == "B")
        {
            if(brB>=brojDoza)
            {
                brB=brB-brojDoza;
                dodeljeneJedinice[i][2] = brojDoza;
                dodeljeneJedinice[i][1]=0;
                dodeljeneJedinice[i][0]=0;

                  dodeljeneJedinice[i][3]=0;
            }
            else if(brO>=brojDoza-brB)
            {

                dodeljeneJedinice[i][0] = brojDoza-brB;
                dodeljeneJedinice[i][2] = brB;
                dodeljeneJedinice[i][1]=0;
                  dodeljeneJedinice[i][3]=0;
                brB=0;
                brO=brO-(brojDoza-brB);
            }
            else
            {
                cout<< "nemoguce";
                return 0;
            }
        }
        if(krvnaGrupa == "AB")
        {
            if(brAB>=brojDoza)
            {
                brAB=brAB-brojDoza;
                dodeljeneJedinice[i][3] = brojDoza;
                dodeljeneJedinice[i][1]=0;
                dodeljeneJedinice[i][2]=0;
                dodeljeneJedinice[i][0]=0;
            }
            else
            {

                zamenaAB[zaZamenuAB][0]=i;
                zamenaAB[zaZamenuAB][1]=brojDoza;
                zaZamenuAB++;
            }

        }
    }
    for(int i =0;i<zaZamenuAB;i++)
    {
        int indeks;
        indeks = zamenaAB[i][0];
        int brojzameneAB = zamenaAB[i][1];
        if(brA>=brojzameneAB-brAB)
        {
            dodeljeneJedinice[indeks][3]=brAB;
            dodeljeneJedinice[indeks][2]=0;
            dodeljeneJedinice[indeks][0]=0;
            dodeljeneJedinice[indeks][1]=brojzameneAB-brAB;
            brA= brA-brojzameneAB-brAB;
            brAB=0;
        }
        else if(brB>=brojzameneAB-brAB-brA)
        {
            dodeljeneJedinice[indeks][3]=brAB;

            dodeljeneJedinice[indeks][1]=brA;

            dodeljeneJedinice[indeks][2]=brojzameneAB-brAB-brA;
              dodeljeneJedinice[indeks][0]=0;
            brB= brB-brojzameneAB-brAB-brA;
            brAB=0;
            brA=0;
        }
        else if(brO>=brojzameneAB-brAB-brA-brB)
        {
            dodeljeneJedinice[indeks][3]=brAB;

            dodeljeneJedinice[indeks][1]=brA;

            dodeljeneJedinice[indeks][2]=brojzameneAB-brAB-brA;

            dodeljeneJedinice[indeks][0]=brojzameneAB-brAB-brA-brB;
            brO= brO-brojzameneAB-brAB-brA-brB;
             brAB=0;
              brA=0;
               brB=0;
        }
        else
        {
            cout<<"nemoguce";
            return 0;
        }
    }
    cout<<"moguce"<<endl;
    for (int i=0 ; i<N; i++)
    {
        cout<<dodeljeneJedinice[i][0]<<" "<<dodeljeneJedinice[i][1]<<" "<<dodeljeneJedinice[i][2]<<" "<<dodeljeneJedinice[i][3]<<endl;
    }
    return 0;
}